function FloatArray(var dValue: Double; var i, j: longint; Action: PChar): Double; cdecl; export;
//
//  by Oleg V. Boldyrev, 1998
//  olegb@post.ctufps.saratov.su
//
// 1. Declare a variable for the array address in the invoking SP
//   DECLARE VARIABLE Array1 INTEGER;
// 2. Allocate memory
//  Array1 = FloatArray(0,0,N,'a');
// 3. Execute actions  ( Index starts from 0 ).
//  Result = FloatArray(Value,Array1,K,'s'); /*Set first K cells to Value*/
//  Result = FloatArray(Value,Array,i,'=');  /*Assign Value to i-th cell*/
//  Result = FloatArray(0,Array1,i,'');      /*Get i-th cell's Value*/
//  Result = FloatArray(0,Array1,K,'S');     /*Sum first K cells*/
// 4. Finished - deallocate memory:
//   Result = FloatArray(0,Array1,N,'d')
// 5. That's all.
type
  TFloatArray = Array[0..0] of Double;
var j0: integer;
    buf: Pointer;
begin
  case Action^ of
    'a':              //allocate memory
     begin
       GetMem(buf, j*SizeOf(Double));
       Result := longint(buf);   //and return the address
       exit;
     end;
    'd':
     begin
       FreeMem(Pointer(i), j*SizeOf(Double)); //deallocate memory
       Result := 0;
       exit;
     end;
  end;

  Result := 0;
  case Action^ of
    '=': TFloatArray(Pointer(i)^)[j] := dValue;
    'S':
      for j0 := 0 to j-1 do
        Result := Result + TFloatArray(Pointer(i)^)[j0];
    's':
      for j0 := 0 to j-1 do
        TFloatArray(Pointer(i)^)[j0] := dValue;
  end;
  case Action^ of
    'S':;
    's':         Result := dValue;
    else  Result := TFloatArray(Pointer(i)^)[j];
  end;
end;
